#include <iostream.h>
#include <math.h>
#include <stdlib.h>

#include "givtimer.C"        // Givaro timing class


struct update_boolean { bool operator ()(bool& x, const bool& y) {
        // If y is true --> really update
    if(y) {
      x=y;
      return 1;
    }
        // else nothing to do !
    return 0;
  }
};

a1_global_sc<update_boolean, bool> time_over;


struct maximum { 
    bool operator ()(int& x, const int& y) {
            // If y is bigger --> broadcast
        if(x<y) {
            x=y;
            return 1;
        }
        return 0;
    }
};


a1_global_ac<maximum, int> The_max;



struct Compute { void operator() (int seuil ) {

        int s = 0;

        bool local_time; time_over.read(local_time);
        while(! local_time) {
                for(int i=0; i< seuil; ++i) {
                        s+=i;
                }
                time_over.read(local_time);
        }
        // update of the maximum
        The_max.update( s );
        cerr << "s=" << s << endl;
        
} };

#include <unistd.h>
struct Alarme { void operator() (int s, int microsec) {
        sleep(s); usleep(microsec);
        // here, no need to update, a write will do without any test
        time_over.write(true);
} };
        


        

int main(int argc, char** argv)
{
 
    Timer tim; tim.clear(); tim.start();

    a1_system::init(argc, argv) ; 

    int nb_sec(1), nb_usec(0);
    if (argc > 1) nb_sec = atoi(argv[1]) ;
    if (argc > 2) nb_usec = atoi(argv[2]) ;

        // Initialize global variable on node 0 
    time_over.regist(0, new bool(false));
    The_max.regist(0, new int(-10));
    
    a1_system::init_commit() ;

    if( a1_system::self_node() == 0 ) {

        Fork< Alarme > () ( nb_sec, nb_usec );
        for(int i = 0; i < 10; ++i) {
                Fork< Compute > () ( 100 ) ;
        }

    }
    a1_system::terminate() ;

    tim.stop();
    int m; The_max.read( m );
    cerr << "Maximum : " << m << ",time: " << tim << endl;

    return 0;
}

